
// Parser generated by Maphoon 2008


#line 1

#include "reader.h"
#include "parser.h"
#include "token.h"
#include "assert.h"

#include "term.h"
#include "context.h"
#include "provergoal.h"
#include "prover.h"

#include "identifier.h"
#include "values.h"


#include <stdlib.h>
#include <vector>
#include <fstream>










//Terminate called after throwing an instance of 'actionerror'
// is sometimes reported is some strange situations. I must check it.
//
//
/* there should exist stub for token ( same as idee.x for parser). Reason: sometimes */
/* we need new types to become available when defining tokens.*/

/* I must remember that % global and %global are not the same.*/
/* Also it cannot be written formula-expected but only formula_expected*/
//%global formula_expected bool








//WISH: distinquish common block for rules BEGIN block and END block 
// grouping common instructions for rules




























//WISH allow '-' in token names
//WISH: Add \ or / to enable breaking too long lines when defining rules in Maphoon





//WISH: I cannot throw an exception from rule. I cannot use line/col numbering from within a rule.

inline void isvalid( const context &cont, 
                     std::vector< context::property > :: const_iterator pr)
{
   std::vector< context::property > :: const_iterator capt = cont. findcapture( pr);
   if ( capt != cont. end( ))
   {
      std::cout << " captured occurences of " << *capt << " in formula "  
                << *pr << " found when istantiating";
      exit( 0 );
   }


}






















// Decide which operator has the priority in a situation
// F1 t1 F2 t2 F3.
// true means left preference, 
// false means right preference. 

bool shouldreduce( const token &t1, const token &t2 )
{
   unsigned int leftattraction;
   bool conflict = false;

   switch( t1. type )
   {
      case tkn_AND:
         leftattraction = 41;
      break;
      case tkn_OR:
         leftattraction = 31;
      break;
      case tkn_IMPLIES:

         if ( t2. type == tkn_EQUIV )
	    conflict = true;  

         leftattraction = 20; 
      break;
      case tkn_EQUIV:

         if ( t2. type == tkn_IMPLIES ||
	      t2. type == tkn_EQUIV )
	    conflict = true;  

         leftattraction = 10;
      break;         
      case tkn_QForall:
      case tkn_QExists:
         leftattraction = 5;
      break;
      default:
         ASSERT(false);
   }

   unsigned int rightattraction;
   switch( t2. type )
   {
      case tkn_AND:
         rightattraction = 40;
      break;
      case tkn_OR:
         rightattraction = 30;
      break;
      case tkn_IMPLIES:
         rightattraction =  21;
      break;
      case tkn_EQUIV:
         rightattraction = 10; 
      break;         
      case tkn_QForall:
      case tkn_QExists:
         rightattraction = 6;
      break;
      default:
         rightattraction = 0;
   }

   if ( conflict )
   {
      std::cout << "Conflict between operators:" << t1 << " and " << t2 << " occured.\n ";
      std::cout << "Decide it manually by using braces\n";
      exit(0);
   }

   return leftattraction > rightattraction;   

   
}

/*WISH: make Maphoon more automatic. Could it be able to convert grammar.txt to LR-grammar?*/


















/*WISH: Maybe distinguish, in each reduction rule,  block for common formula declaration.*/
/* Comments in Maphoon?*/








/* constraints should be richer ( for example they should be able to represent unions of attributes*/






//WISH: grammar definition should be separated from attribute handling.
// Could Maphoon enforce this?





//#define MAPH_DEBUG 1 


struct parameters
{

   std::string configfilename;
   // File from which configuration is read.
   // Command line parameters can override those settings.
   // (handling command line params not present yet)

   std::string inputfilename;
   // File from which input is read. If inputfilename = empty, input
   // will be read from standard input.

   std::ifstream* inputstream;


   explicit parameters( const std::list< std::string > & pars ):
	configfilename( "" ),
	inputfilename( "" ),
	inputstream(0)  
   {

      if( pars. size( ) == 0 )
      {
         std::cout << "ERROR: There should be at least one parameter\n\n";
	 exit(0);
      }

      std::list< std::string > :: const_iterator p = pars. begin( ); 
      ++ p;

      while( p != pars. end( ))
      {

	 if( *p == "-inputfile" ) 
         {
            ++ p;
	    if( p == pars. end( ))
            {
               std::cout << "ERROR: expecting filename after -inputfile\n\n";
	       exit(0);
            }

	    if( inputfilename. size( ))
            {
               std::cout << "ERROR: multiple filenames\n\n";
	       exit(0);
            }

	    inputfilename = *(p++);
	    inputstream = new std::ifstream( inputfilename. c_str( ));
            if( ! ( *inputstream ))
            {
               std::cout << "ERROR: ";
	       std::cout << "could not open inputfile ";
	       std::cout << inputfilename<< "\n\n";
	       exit(0);
            }

            goto recognized;
         }
  
         if( *p == "-configfile")
	 {
            ++ p;
	    if( p == pars. end( ))
            {
               std::cout << "ERROR: expecting filename after -configfile\n\n";
	       exit(0);
            }

	    if( configfilename. size( ))
            {
               std::cout << "ERROR: multiple filenames\n\n";
	       exit(0);
            }

	    configfilename = *(p++);
            goto recognized;
         }

      
	 std::cout << "ERROR: unrecognized parameter: " << *(p++);
	 std::cout << "\n";
	 exit(0);

      recognized:
	 ;
      }


      if ( ! configfilename. size( ) )
      {
         std::cout << "ERROR: ";
	 std::cout << "configfile not specified ";
         exit(0);
      }

   }


   ~parameters( )
   {
      delete inputstream;
   }


};



std::ostream& operator << ( std::ostream& stream , const parameters& pars )
{
   stream << "Parameters:\n\n";

   stream << "configfile =      " << ( pars. configfilename. size( ) ?
	                               pars. configfilename :
				       "not present" ) << "\n";
   stream << "inputfile =      " << ( pars. inputfilename. size( ) ?
	                               pars. inputfilename :
				       "(stdin)" ) << "\n";
   stream << "\n";
   return stream;
}


int main( int cntr, char *args[ ]) 
{

context c;
prover p ; // = prover::readprover("geo_parameters");

   std::list< std::string > pppp;
   for( unsigned int i = 0; i < cntr; ++ i )
   {
      pppp. push_back( args [i] );
   }

   if ( cntr == 1)
   {
      std::cout << "\n Parameters:\n\n";
      std::cout << " -configfile file - file with configuration data ( see prover.h for description)\n";
      std::cout << " -inputfile  file - input file name\n\n";
      exit(0);
   }
   parameters pars = parameters::parameters( pppp );


   std::cout << "\n";
   std::cout << pars << "\n";

   try 
   {
      p = prover::readprover( pars. configfilename ); 
   }
   catch ( prover::readerror re)
   {
      std::cout << "ERROR: ";
      std::cout << re;
      exit(0);
   }

   reader r  =
      ( pars. inputfilename. size( ) ? 
	       reader::reader( *( pars. inputstream ),
			                        pars. inputfilename ) :
	       reader::reader( )
      );



unsigned int bottom = 0;


 try
   {
      parser( r, c, p, bottom, tkn_Proof, 5);
   } 
   catch( notfirstorder nfof)
   {
      std::cout << nfof;
   }
   catch( prover::readerror re)
   {
      std::cout << re;
   }
   catch( prover::writeerror we)
   {
      std::cout << we;
   }

   std::cout << std::endl;
   std::cout << "Parsing ended in line " << r. linenumber << std::endl;
   std::cout << "End of program";

   std::cout << "{ "; 
   for( std::list< token > :: const_iterator
           p = r. lookahead. begin( );
           p != r. lookahead. end( );
           ++ p )
   {
      if( p != r. lookahead. begin( ))
         std::cout << ", ";
      std::cout << *p;
   }
   std::cout << " }\n"; 

   std::cout << c;
return 0;

}





#include "token.h"
#include "reader.h"
#include "parser.h"




// Code generated by Maphoon 2008. 
// Written by Hans de Nivelle, June 2008.



namespace
{
   struct refused
   {
   };

   std::ostream& operator << ( std::ostream& stream, refused ref )
   {
      stream << "REFUSED";
      return stream;
   }
}



namespace
{

// Here come the tables:

   unsigned int starts [] = 
   {
      0, 18, 44, 47, 57, 67, 70, 73, 76, 79, 99, 
      157, 163, 175, 177, 179, 182, 185, 187, 189, 200, 
      202, 204, 207, 209, 211, 214, 217, 220, 223, 226, 
      229, 231, 233, 235, 242, 245, 248, 251, 254, 257, 
      260, 266, 268, 276, 286, 291, 293, 295, 300, 305, 
      307, 309, 366, 381, 385, 387, 389, 391, 393, 450, 
      507, 511, 513, 517, 521, 524, 528, 536, 541, 546, 
      548, 559, 562, 564, 566, 568, 570, 572, 575, 578, 
      585, 595, 597, 599, 602, 609, 612, 669, 726, 783, 
      840, 847, 849, 856, 858, 865, 867, 874, 877, 880, 
      883, 886, 894, 896, 898, 958, 961, 964, 967, 969, 
      971, 975, 977, 980, 984, 999, 1003, 1009, 1016, 1018, 
      1021, 1023, 1026, 1028, 1031, 1034, 1037, 1040, 1042, 1045, 
      1048, 1051, 1054, 1058, 1060, 1062, 1065, 1070, 1073, 1080, 
      1083, 1086, 1088, 1091, 1094, 1097, 1100, 1102, 1106, 1109, 
      1111, 1113, 1115, 1117, 1124, 1131, 1134, 1137, 1152, 1155, 
      1157, 1159, 1161, 1166, 1179, 1194, 1196, 1198, 1201, 1204, 
      1207, 0 };

   unsigned int defaults [] = {
      0, 1, 2, 3, 0, 5, 6, 7, 8, 9, 10, 
      1, 12, 12, 11, 15, 16, 17, 18, 19, 11, 
      11, 22, 23, 24, 25, 26, 27, 28, 29, 30, 
      31, 32, 1, 34, 35, 36, 37, 38, 39, 40, 
      41, 11, 10, 44, 45, 46, 47, 48, 49, 50, 
      51, 52, 53, 54, 11, 11, 11, 11, 59, 60, 
      61, 62, 63, 64, 65, 9, 4, 68, 69, 70, 
      71, 72, 12, 74, 75, 12, 12, 78, 79, 80, 
      81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 
      91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 
      101, 4, 41, 41, 105, 106, 107, 108, 109, 110, 
      111, 81, 113, 114, 115, 116, 117, 118, 1, 120, 
      117, 122, 1, 124, 125, 126, 127, 128, 129, 130, 
      131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 
      141, 1, 143, 144, 145, 146, 81, 148, 149, 116, 
      54, 152, 111, 154, 155, 156, 157, 158, 159, 54, 
      11, 162, 163, 164, 165, 114, 114, 168, 169, 170, 
      0 };

   int parsetable [] = 
   {
      tkn_PROVE, 10001, 
      tkn_ASSUME, 10002, 
      tkn_DEFINE, 10003, 
      tkn_Proof, 10004, 
      tkn_Prove, 10005, 
      tkn_Permanent_Definition, 10006, 
      tkn_Assumptions, 10007, 
      tkn_Permanent_Assumptions, 10008, 
      tkn_ASSUMERed, 10009, 
      tkn_IDENTIFIER, 10010, 
      tkn_LPAR, 10011, 
      tkn_LSQBR, 10012, 
      tkn_LANGBR, 10013, 
      tkn_NOT, 10014, 
      tkn_TRUE, 10015, 
      tkn_FALSE, 10016, 
      tkn_Labeled_Formula, 10017, 
      tkn_Term, 10018, 
      tkn_Formula, 10019, 
      tkn_QForall, 10020, 
      tkn_QExists, 10021, 
      tkn_Atom, 10022, 
      tkn__defaultred, -10014, 0, 
      tkn_FUNCTION, 10023, 
      tkn_PREDICATE, 10024, 
      tkn_Define_Predicate, 10025, 
      tkn_Define_Function_byPred, 10026, 
      tkn_Define_Function_byTerm, 10027, 
      tkn_Proof, 0, 
      tkn_Prove, 10028, 
      tkn_Permanent_Definition, 10029, 
      tkn_Assumptions, 10030, 
      tkn_Permanent_Assumptions, 0, 
      tkn__defaultred, -10003, 0, 
      tkn__defaultred, -10004, 0, 
      tkn__defaultred, -10006, 0, 
      tkn__defaultred, -10005, 0, 
      tkn_FUNCTION, 10031, 
      tkn_PREDICATE, 10032, 
      tkn_FORMULA, 10033, 
      tkn_Declarations, 10034, 
      tkn_Declaration, 10035, 
      tkn_Function_Declaration, 10036, 
      tkn_Predicate_Declaration, 10037, 
      tkn_Formula_Declaration, 10038, 
      tkn_Assume_Defined_Predicate, 10039, 
      tkn_Assume_Defined_Function, 10040, 
      tkn_EOF, -10076, 0, 
      tkn_LPAR, 10041, 
      tkn_COMMA, -10076, 0, 
      tkn_COLON, 10042, 
      tkn_IN, -10076, 0, 
      tkn_END, -10076, 0, 
      tkn_AND, -10076, 0, 
      tkn_OR, -10076, 0, 
      tkn_IMPLIES, -10076, 0, 
      tkn_EQUIV, -10076, 0, 
      tkn_EQ, -10080, 0, 
      tkn_PROVE, -10076, 0, 
      tkn_FROM, -10076, 0, 
      tkn_ASSUME, -10076, 0, 
      tkn_DEFINE, -10076, 0, 
      tkn_EXISTENCE, -10076, 0, 
      tkn_Prove, -10076, 0, 
      tkn_Permanent_Definition, -10076, 0, 
      tkn_Assumptions, -10076, 0, 
      tkn_ASSUMERed, -10076, 0, 
      tkn_IDENTIFIER, 10043, 
      tkn_Labeled_Formula, 0, 
      tkn_Formula, 10044, 
      tkn_IDENTIFIER, 10045, 
      tkn_FUNCTION, 10046, 
      tkn_PREDICATE, 10047, 
      tkn_Function_Declaration, 10048, 
      tkn_Predicate_Declaration, 10049, 
      tkn_Bound_list, 10050, 
      tkn_Bound_list, 10051, 
      tkn_Formula, 10052, 
      tkn__defaultred, -10072, 0, 
      tkn__defaultred, -10071, 0, 
      tkn_FROM, 10053, 
      tkn_EQ, 10054, 
      tkn__defaultred, -10062, 0, 
      tkn_AND, 10055, 
      tkn_OR, 10056, 
      tkn_IMPLIES, 10057, 
      tkn_EQUIV, 10058, 
      tkn_Formula, 10059, 
      tkn_Formula, 10060, 
      tkn__defaultred, -10073, 0, 
      tkn_IDENTIFIER, 10061, 
      tkn_IDENTIFIER, 10062, 
      tkn__defaultred, -10029, 0, 
      tkn__defaultred, -10030, 0, 
      tkn__defaultred, -10031, 0, 
      tkn__defaultred, -10000, 0, 
      tkn__defaultred, -10001, 0, 
      tkn__defaultred, -10002, 0, 
      tkn_IDENTIFIER, 10063, 
      tkn_IDENTIFIER, 10064, 
      tkn_Labeled_Formula, 10065, 
      tkn__defaultred, -10015, 0, 
      tkn_COMMA, 10066, 
      tkn_IN, 10067, 
      tkn__defaultred, -10018, 0, 
      tkn__defaultred, -10019, 0, 
      tkn__defaultred, -10020, 0, 
      tkn__defaultred, -10021, 0, 
      tkn__defaultred, -10022, 0, 
      tkn__defaultred, -10023, 0, 
      tkn_IDENTIFIER, 10068, 
      tkn_Term, 10069, 
      tkn_Term_list, 10070, 
      tkn_Formula, 10071, 
      tkn_RPAR, -10076, 0, 
      tkn_RSQBR, -10076, 0, 
      tkn_COLON, 0, 
      tkn_RPAR, 10072, 
      tkn_AND, 10055, 
      tkn_OR, 10056, 
      tkn_IMPLIES, 10057, 
      tkn_EQUIV, 10058, 
      tkn__defaultred, -10057, 0, 
      tkn_COMMA, 10073, 
      tkn_IDENTIFIER, 10074, 
      tkn_IDENTIFIER, 10075, 
      tkn__defaultred, -10053, 0, 
      tkn_COMMA, 10076, 
      tkn__defaultred, -10054, 0, 
      tkn_COMMA, 10077, 
      tkn_RSQBR, 10078, 
      tkn_RANGBR, 10079, 
      tkn_EOF, -10069, 0, 
      tkn_RPAR, -10069, 0, 
      tkn_RSQBR, -10069, 0, 
      tkn_COMMA, -10069, 0, 
      tkn_IN, -10069, 0, 
      tkn_END, -10069, 0, 
      tkn_AND, -10069, 10055, 
      tkn_OR, -10069, 10056, 
      tkn_IMPLIES, -10069, 10057, 
      tkn_EQUIV, -10069, 10058, 
      tkn_PROVE, -10069, 0, 
      tkn_FROM, -10069, 0, 
      tkn_ASSUME, -10069, 0, 
      tkn_DEFINE, -10069, 0, 
      tkn_EXISTENCE, -10069, 0, 
      tkn_Prove, -10069, 0, 
      tkn_Permanent_Definition, -10069, 0, 
      tkn_Assumptions, -10069, 0, 
      tkn_ASSUMERed, -10069, 0, 
      tkn__defaultred, -10037, 0, 
      tkn_IDENTIFIER, 10080, 
      tkn_LPAR, 10081, 
      tkn_MP, 10082, 
      tkn_MINUS, 10083, 
      tkn_References, 10084, 
      tkn_Reference, 10085, 
      tkn_IDENTIFIER, 10068, 
      tkn_Term, 10086, 
      tkn_Formula, 10087, 
      tkn_Formula, 10088, 
      tkn_Formula, 10089, 
      tkn_Formula, 10090, 
      tkn_EOF, -10068, 0, 
      tkn_RPAR, -10068, 0, 
      tkn_RSQBR, -10068, 0, 
      tkn_COMMA, -10068, 0, 
      tkn_IN, -10068, 0, 
      tkn_END, -10068, 0, 
      tkn_AND, -10068, 10055, 
      tkn_OR, -10068, 10056, 
      tkn_IMPLIES, -10068, 10057, 
      tkn_EQUIV, -10068, 10058, 
      tkn_PROVE, -10068, 0, 
      tkn_FROM, -10068, 0, 
      tkn_ASSUME, -10068, 0, 
      tkn_DEFINE, -10068, 0, 
      tkn_EXISTENCE, -10068, 0, 
      tkn_Prove, -10068, 0, 
      tkn_Permanent_Definition, -10068, 0, 
      tkn_Assumptions, -10068, 0, 
      tkn_ASSUMERed, -10068, 0, 
      tkn_EOF, -10067, 0, 
      tkn_RPAR, -10067, 0, 
      tkn_RSQBR, -10067, 0, 
      tkn_COMMA, -10067, 0, 
      tkn_IN, -10067, 0, 
      tkn_END, -10067, 0, 
      tkn_AND, -10067, 10055, 
      tkn_OR, -10067, 10056, 
      tkn_IMPLIES, -10067, 10057, 
      tkn_EQUIV, -10067, 10058, 
      tkn_PROVE, -10067, 0, 
      tkn_FROM, -10067, 0, 
      tkn_ASSUME, -10067, 0, 
      tkn_DEFINE, -10067, 0, 
      tkn_EXISTENCE, -10067, 0, 
      tkn_Prove, -10067, 0, 
      tkn_Permanent_Definition, -10067, 0, 
      tkn_Assumptions, -10067, 0, 
      tkn_ASSUMERed, -10067, 0, 
      tkn_BY, 10091, 
      tkn_INDIRECTLY, 10092, 
      tkn_BY, 10093, 
      tkn_COLON, 10094, 
      tkn_COLONEQ, 10095, 
      tkn_COLON, 10096, 
      tkn_COLONEQ, 10097, 
      tkn__defaultred, -10026, 0, 
      tkn_Declarations, 0, 
      tkn_Declaration, 10098, 
      tkn_Prove, 10099, 
      tkn_Permanent_Definition, 10100, 
      tkn_Assumptions, 10101, 
      tkn_Subproof, 10102, 
      tkn__defaultred, -10080, 0, 
      tkn_LPAR, 10103, 
      tkn__defaultred, -10082, 0, 
      tkn_COMMA, 10104, 
      tkn_RPAR, 10105, 
      tkn__defaultred, -10061, 0, 
      tkn_AND, 10055, 
      tkn_OR, 10056, 
      tkn_IMPLIES, 10057, 
      tkn_EQUIV, 10058, 
      tkn__defaultred, -10070, 0, 
      tkn_Bound_list, 10106, 
      tkn_COLON, 10094, 
      tkn_COLON, 10096, 
      tkn_Bound_list, 10107, 
      tkn_Bound_list, 10108, 
      tkn__defaultred, -10059, 0, 
      tkn__defaultred, -10060, 0, 
      tkn__defaultred, -10039, 0, 
      tkn_MINUS, 10109, 
      tkn_PLUS, 10110, 
      tkn_IDENTIFIER, 10080, 
      tkn_LPAR, 10081, 
      tkn_MP, 10082, 
      tkn_MINUS, 10083, 
      tkn_Reference, 10111, 
      tkn_LPAR, 10112, 
      tkn_UNSIGNED, 10113, 
      tkn__defaultred, -10013, 0, 
      tkn__defaultred, -10036, 0, 
      tkn_LSQBR, 10114, 
      tkn_COMMA, 10115, 
      tkn__defaultred, -10074, 0, 
      tkn_EOF, -10063, 0, 
      tkn_RPAR, -10063, 0, 
      tkn_RSQBR, -10063, 0, 
      tkn_COMMA, -10063, 0, 
      tkn_IN, -10063, 0, 
      tkn_END, -10063, 0, 
      tkn_AND, -10063, 10055, 
      tkn_OR, -10063, 10056, 
      tkn_IMPLIES, -10063, 10057, 
      tkn_EQUIV, -10063, 10058, 
      tkn_PROVE, -10063, 0, 
      tkn_FROM, -10063, 0, 
      tkn_ASSUME, -10063, 0, 
      tkn_DEFINE, -10063, 0, 
      tkn_EXISTENCE, -10063, 0, 
      tkn_Prove, -10063, 0, 
      tkn_Permanent_Definition, -10063, 0, 
      tkn_Assumptions, -10063, 0, 
      tkn_ASSUMERed, -10063, 0, 
      tkn_EOF, -10064, 0, 
      tkn_RPAR, -10064, 0, 
      tkn_RSQBR, -10064, 0, 
      tkn_COMMA, -10064, 0, 
      tkn_IN, -10064, 0, 
      tkn_END, -10064, 0, 
      tkn_AND, -10064, 10055, 
      tkn_OR, -10064, 10056, 
      tkn_IMPLIES, -10064, 10057, 
      tkn_EQUIV, -10064, 10058, 
      tkn_PROVE, -10064, 0, 
      tkn_FROM, -10064, 0, 
      tkn_ASSUME, -10064, 0, 
      tkn_DEFINE, -10064, 0, 
      tkn_EXISTENCE, -10064, 0, 
      tkn_Prove, -10064, 0, 
      tkn_Permanent_Definition, -10064, 0, 
      tkn_Assumptions, -10064, 0, 
      tkn_ASSUMERed, -10064, 0, 
      tkn_EOF, -10065, 0, 
      tkn_RPAR, -10065, 0, 
      tkn_RSQBR, -10065, 0, 
      tkn_COMMA, -10065, 0, 
      tkn_IN, -10065, 0, 
      tkn_END, -10065, 0, 
      tkn_AND, -10065, 10055, 
      tkn_OR, -10065, 10056, 
      tkn_IMPLIES, -10065, 10057, 
      tkn_EQUIV, -10065, 10058, 
      tkn_PROVE, -10065, 0, 
      tkn_FROM, -10065, 0, 
      tkn_ASSUME, -10065, 0, 
      tkn_DEFINE, -10065, 0, 
      tkn_EXISTENCE, -10065, 0, 
      tkn_Prove, -10065, 0, 
      tkn_Permanent_Definition, -10065, 0, 
      tkn_Assumptions, -10065, 0, 
      tkn_ASSUMERed, -10065, 0, 
      tkn_EOF, -10066, 0, 
      tkn_RPAR, -10066, 0, 
      tkn_RSQBR, -10066, 0, 
      tkn_COMMA, -10066, 0, 
      tkn_IN, -10066, 0, 
      tkn_END, -10066, 0, 
      tkn_AND, -10066, 10055, 
      tkn_OR, -10066, 10056, 
      tkn_IMPLIES, -10066, 10057, 
      tkn_EQUIV, -10066, 10058, 
      tkn_PROVE, -10066, 0, 
      tkn_FROM, -10066, 0, 
      tkn_ASSUME, -10066, 0, 
      tkn_DEFINE, -10066, 0, 
      tkn_EXISTENCE, -10066, 0, 
      tkn_Prove, -10066, 0, 
      tkn_Permanent_Definition, -10066, 0, 
      tkn_Assumptions, -10066, 0, 
      tkn_ASSUMERed, -10066, 0, 
      tkn__defaultred, -10050, 0, 
      tkn_LAMBDA, 10116, 
      tkn_Lambda_Bound_Vars, 10117, 
      tkn_BY, 10118, 
      tkn__defaultred, -10050, 0, 
      tkn_LAMBDA, 10116, 
      tkn_Lambda_Bound_Vars, 10119, 
      tkn_UNSIGNED, 10120, 
      tkn__defaultred, -10050, 0, 
      tkn_LAMBDA, 10116, 
      tkn_Lambda_Bound_Vars, 10121, 
      tkn_UNSIGNED, 10122, 
      tkn__defaultred, -10050, 0, 
      tkn_LAMBDA, 10116, 
      tkn_Lambda_Bound_Vars, 10123, 
      tkn__defaultred, -10017, 0, 
      tkn__defaultred, -10010, 0, 
      tkn__defaultred, -10012, 0, 
      tkn__defaultred, -10011, 0, 
      tkn_END, 10124, 
      tkn_Prove, 10125, 
      tkn_Permanent_Definition, 10126, 
      tkn_Assumptions, 10127, 
      tkn_Term_list, 10128, 
      tkn_Term_list, 10129, 
      tkn_EOF, -10075, 0, 
      tkn_RPAR, -10075, 0, 
      tkn_RSQBR, -10075, 0, 
      tkn_COMMA, -10075, 0, 
      tkn_IN, -10075, 0, 
      tkn_END, -10075, 0, 
      tkn_AND, -10075, 0, 
      tkn_OR, -10075, 0, 
      tkn_IMPLIES, -10075, 0, 
      tkn_EQUIV, -10075, 0, 
      tkn_EQ, -10079, 0, 
      tkn_PROVE, -10075, 0, 
      tkn_FROM, -10075, 0, 
      tkn_ASSUME, -10075, 0, 
      tkn_DEFINE, -10075, 0, 
      tkn_EXISTENCE, -10075, 0, 
      tkn_Prove, -10075, 0, 
      tkn_Permanent_Definition, -10075, 0, 
      tkn_Assumptions, -10075, 0, 
      tkn_ASSUMERed, -10075, 0, 
      tkn__defaultred, -10058, 0, 
      tkn__defaultred, -10055, 0, 
      tkn__defaultred, -10056, 0, 
      tkn_UNSIGNED, 10130, 
      tkn_UNSIGNED, 10131, 
      tkn_RPAR, 10132, 
      tkn_LSQBR, 10114, 
      tkn_Reference, 10133, 
      tkn__defaultred, -10038, 0, 
      tkn_IDENTIFIER, 10134, 
      tkn_Instantiations, 10135, 
      tkn__defaultred, -10037, 0, 
      tkn_IDENTIFIER, 10080, 
      tkn_LPAR, 10081, 
      tkn_MP, 10082, 
      tkn_MINUS, 10083, 
      tkn_References, 10136, 
      tkn_Reference, 10085, 
      tkn_IDENTIFIER, 10137, 
      tkn_Ident_list, 10138, 
      tkn_IDENTIFIER, 10139, 
      tkn_Labeled_Term, 10140, 
      tkn_Term, 10141, 
      tkn__defaultred, -10050, 0, 
      tkn_LAMBDA, 10116, 
      tkn_Lambda_Bound_Vars, 10142, 
      tkn_Labeled_Formula, 10143, 
      tkn__defaultred, -10024, 0, 
      tkn_Labeled_Term, 10144, 
      tkn__defaultred, -10025, 0, 
      tkn_Labeled_Formula, 10145, 
      tkn__defaultred, -10016, 0, 
      tkn__defaultred, -10007, 0, 
      tkn__defaultred, -10009, 0, 
      tkn__defaultred, -10008, 0, 
      tkn_RPAR, 10146, 
      tkn__defaultred, -10081, 0, 
      tkn__defaultred, -10041, 0, 
      tkn__defaultred, -10040, 0, 
      tkn__defaultred, -10044, 0, 
      tkn_LSQBR, 10114, 
      tkn_COMMA, 10147, 
      tkn_COLONEQ, 10148, 
      tkn_RSQBR, 10149, 
      tkn__defaultred, -10035, 0, 
      tkn__defaultred, -10052, 0, 
      tkn_COMMA, 10150, 
      tkn__defaultred, -10049, 0, 
      tkn__defaultred, -10080, 0, 
      tkn_LPAR, 10103, 
      tkn_COLON, 10151, 
      tkn__defaultred, -10034, 0, 
      tkn__defaultred, -10078, 0, 
      tkn_Labeled_Formula, 10152, 
      tkn__defaultred, -10032, 0, 
      tkn__defaultred, -10028, 0, 
      tkn__defaultred, -10027, 0, 
      tkn__defaultred, -10079, 0, 
      tkn_Reference, 10153, 
      tkn_FUNCTION, 10154, 
      tkn_PREDICATE, 10155, 
      tkn__defaultred, -10042, 0, 
      tkn_Ident_list, 10156, 
      tkn_Term, 10157, 
      tkn_EXISTENCE, 10158, 
      tkn_RPAR, 10159, 
      tkn__defaultred, -10050, 0, 
      tkn_LAMBDA, 10116, 
      tkn_Lambda_Bound_Vars, 10160, 
      tkn__defaultred, -10050, 0, 
      tkn_LAMBDA, 10116, 
      tkn_Lambda_Bound_Vars, 10161, 
      tkn__defaultred, -10051, 0, 
      tkn__defaultred, -10077, 0, 
      tkn__defaultred, -10037, 0, 
      tkn_IDENTIFIER, 10080, 
      tkn_LPAR, 10081, 
      tkn_MP, 10082, 
      tkn_MINUS, 10083, 
      tkn_References, 10162, 
      tkn_Reference, 10085, 
      tkn__defaultred, -10043, 0, 
      tkn_Term, 10163, 
      tkn_Formula, 10164, 
      tkn_UNIQUENESS, 10165, 
      tkn__defaultred, -10047, 0, 
      tkn_COMMA, 10166, 
      tkn__defaultred, -10048, 0, 
      tkn_COMMA, 10167, 
      tkn_AND, 10055, 
      tkn_OR, 10056, 
      tkn_IMPLIES, 10057, 
      tkn_EQUIV, 10058, 
      tkn__defaultred, -10037, 0, 
      tkn_IDENTIFIER, 10080, 
      tkn_LPAR, 10081, 
      tkn_MP, 10082, 
      tkn_MINUS, 10083, 
      tkn_References, 10168, 
      tkn_Reference, 10085, 
      tkn_Instantiations, 10169, 
      tkn_Instantiations, 10170, 
      tkn__defaultred, -10033, 0, 
      tkn__defaultred, -10045, 0, 
      tkn__defaultred, -10046, 0, 
   0 };

   int entrypoints [] = 
   {
      tkn_Proof, 0, tkn_EOF, -1,
      -1
   };



}


namespace
{


   // There are two reduce functions.
   // 
   // The first returns a token from the parse stack.
   // The other tokens are removed, and it is checked that the
   // token has the right type.
   // 
   // The second returns a new token. All tokens from the parse stack
   // are removed, and the new token is pushed.

   void reduce( std::list< token > & parsestack,
                std::list< token > :: iterator position,
                tokentype expectedtype,
                std::list< token > :: const_iterator result )
   {
      ASSERT( result -> type == expectedtype );
         // Must be type of lhs. 
      ASSERT( result -> iswellformed( ));

      bool seen = false;
      while( position != parsestack. end( ))
      {
         if( position == result )
         {
            ASSERT( !seen );
            seen = true;
            ++ position;
         }
         else
         {
            std::list< token > :: iterator p1 = position;
            ++ position; 
            parsestack. erase( p1 );
         }
      }
      ASSERT( seen );
   }


   void reduce( std::list< token > & parsestack,
                std::list< token > :: iterator position,
                tokentype expectedtype,
                const token& result )
   {
      ASSERT( result. type == expectedtype ); 
      ASSERT( result. iswellformed( )); 

      while( position != parsestack. end( ))
      {
         ASSERT( & (*position) != & result );
            // If this happenes, the user typed 'return *T'
            // for an attribute variable. 
            // He should have typed 'return T' instead. 
  
         std::list< token > :: iterator p1 = position;
         ++ position;
         parsestack. erase( p1 ); 
      }

      parsestack. insert( position, result ); 
   }


   // This is not terribly efficient, but we expect the size of the
   // rules to be moderate.

   std::list< token > :: iterator 
   operator - ( std::list< token > :: iterator p,
                unsigned int diff )
   {
      while( diff > 0 )
      {
         -- diff; 
         -- p;
      }
      return p; 
   }


// Here come the actions:

void reduction_0(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Proof1,
   std::list< token > :: iterator Prove2 ) throw( refused )
{

#line 74 "checker.m"

{ reduce( stack, position, tkn_Proof, tkn_Proof ); return; }

}


void reduction_1(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Proof1,
   std::list< token > :: iterator Permanent_Definition2 ) throw( refused )
{

#line 75 "checker.m"

{ reduce( stack, position, tkn_Proof, tkn_Proof ); return; }

}


void reduction_2(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Proof1,
   std::list< token > :: iterator Assumptions2 ) throw( refused )
{

#line 76 "checker.m"

{ reduce( stack, position, tkn_Proof, tkn_Proof ); return; }

}


void reduction_3(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Prove1 ) throw( refused )
{

#line 77 "checker.m"

{ reduce( stack, position, tkn_Proof, tkn_Proof ); return; }

}


void reduction_4(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Permanent_Definition1 ) throw( refused )
{

#line 78 "checker.m"

{ reduce( stack, position, tkn_Proof, tkn_Proof ); return; }

}


void reduction_5(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Permanent_Assumptions1 ) throw( refused )
{

#line 79 "checker.m"

{ reduce( stack, position, tkn_Proof, tkn_Proof ); return; }

}


void reduction_6(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Assumptions1 ) throw( refused )
{

#line 80 "checker.m"

{ reduce( stack, position, tkn_Proof, tkn_Proof ); return; }

}


void reduction_7(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Subproof1,
   std::list< token > :: iterator Prove2 ) throw( refused )
{

#line 84 "checker.m"

{ reduce( stack, position, tkn_Subproof, tkn_Subproof ); return; }

}


void reduction_8(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Subproof1,
   std::list< token > :: iterator Assumptions2 ) throw( refused )
{

#line 85 "checker.m"

{ reduce( stack, position, tkn_Subproof, tkn_Subproof ); return; }

}


void reduction_9(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Subproof1,
   std::list< token > :: iterator Permanent_Definition2 ) throw( refused )
{

#line 86 "checker.m"

{ reduce( stack, position, tkn_Subproof, tkn_Subproof ); return; }

}


void reduction_10(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Prove1 ) throw( refused )
{

#line 87 "checker.m"

{ reduce( stack, position, tkn_Subproof, tkn_Subproof ); return; }

}


void reduction_11(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Assumptions1 ) throw( refused )
{

#line 88 "checker.m"

{ reduce( stack, position, tkn_Subproof, tkn_Subproof ); return; }

}


void reduction_12(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Permanent_Definition1 ) throw( refused )
{

#line 89 "checker.m"

{ reduce( stack, position, tkn_Subproof, tkn_Subproof ); return; }

}


void reduction_13(
   std::list< token > & stack,
   context& cont, 
   prover& pr, 
   std::list< token > :: iterator position,
   std::list< token > :: iterator PROVE1,
   std::list< token > :: iterator Labeled_Formula2,
   std::list< token > :: iterator FROM3,
   std::list< token > :: iterator References4 ) throw( refused )
{

#line 95 "checker.m"


try
{
cont. checkdeclarations( Labeled_Formula2 -> f. front( ) );
}
catch( context::undeclaredidentifier ui)
{
std::cout << ui ;
exit(0);
}


provergoal pg( std::list< formula > :: list( ),
References4 -> f,
Labeled_Formula2 -> f. front( ));


try
{
if ( ! pr. trytoprove( pg ) )
{
std::cout << " unable to prove: " << pg << "\n";
exit(0);
}
}
catch( notfirstorder nfof)
{
std::cout << nfof;
exit(0);
}
catch( prover::readerror re)
{
std::cout << re;
exit(0);
}
catch( prover::writeerror we)
{
std::cout << we;
exit(0);
}

if ( Labeled_Formula2 -> label. size( ) > 0 )
{
cont. proveformula( Labeled_Formula2 -> label. front( ),
Labeled_Formula2 -> f. front( ),
true,
std::string("Proven by ") + pr. name);
}
else
{
cont. proveformula( Labeled_Formula2 -> f. front( ),
true,
std::string("Proven by ") + pr. name);
}
{ reduce( stack, position, tkn_Prove, tkn_Prove ); return; }

}


void reduction_14(
   std::list< token > & stack,
   context& cont, 
   unsigned int& bottom, 
   std::list< token > :: iterator position,
   std::list< token > :: iterator ASSUME1 ) throw( refused )
{

#line 156 "checker.m"


bottom = cont. size( );
{ reduce( stack, position, tkn_ASSUMERed, tkn_ASSUMERed ); return; }

}


void reduction_15(
   std::list< token > & stack,
   context& cont, 
   unsigned int& bottom, 
   std::list< token > :: iterator position,
   std::list< token > :: iterator ASSUMERed1,
   std::list< token > :: iterator Declarations2,
   const std::list< token > & lookahead ) throw( refused )
{

#line 162 "checker.m"

if ( ! lookahead. size( ) || lookahead. front( ). type != tkn_IN )
{
// change default scope of Declarations to permanent
cont. changescope( bottom, true);
}
else
throw refused::refused( );

{ reduce( stack, position, tkn_Assumptions, tkn_Assumptions ); return; }

}


void reduction_16(
   std::list< token > & stack,
   context& cont, 
   unsigned int& bottom, 
   std::list< token > :: iterator position,
   std::list< token > :: iterator ASSUMERed1,
   std::list< token > :: iterator Declarations2,
   std::list< token > :: iterator IN3,
   std::list< token > :: iterator Subproof4,
   std::list< token > :: iterator END5 ) throw( refused )
{

#line 171 "checker.m"

// changescope neednt be called

// Backtrack:
try
{
cont. backtrack( bottom );
}
catch( context::cannotabstractform caf)
{
std::cout << caf;
exit(0);
}
catch( context:: cannotabstractdecl cad)
{
std::cout << cad;
exit(0);
}

{ reduce( stack, position, tkn_Assumptions, tkn_Assumptions ); return; }

}


void reduction_17(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Declarations1,
   std::list< token > :: iterator COMMA2,
   std::list< token > :: iterator Declaration3 ) throw( refused )
{

#line 194 "checker.m"

{ reduce( stack, position, tkn_Declarations, tkn_Declarations ); return; }

}


void reduction_18(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Declaration1 ) throw( refused )
{

#line 195 "checker.m"

{ reduce( stack, position, tkn_Declarations, tkn_Declarations ); return; }

}


void reduction_19(
   std::list< token > & stack,
   context& cont, 
   std::list< token > :: iterator position,
   std::list< token > :: iterator Function_Declaration1 ) throw( refused )
{

#line 198 "checker.m"


cont. assumefunction( Function_Declaration1 -> d. front( ). var,
Function_Declaration1 -> d. front( ). arity,
false );


{ reduce( stack, position, tkn_Declaration, tkn_Declaration ); return; }

}


void reduction_20(
   std::list< token > & stack,
   context& cont, 
   std::list< token > :: iterator position,
   std::list< token > :: iterator Predicate_Declaration1 ) throw( refused )
{

#line 205 "checker.m"


cont. assumepredicate( Predicate_Declaration1 -> d. front( ). var,
Predicate_Declaration1 -> d. front( ). arity,
false );

{ reduce( stack, position, tkn_Declaration, tkn_Declaration ); return; }

}


void reduction_21(
   std::list< token > & stack,
   context& cont, 
   std::list< token > :: iterator position,
   std::list< token > :: iterator Formula_Declaration1 ) throw( refused )
{

#line 211 "checker.m"


try
{
cont. checkdeclarations( Formula_Declaration1 -> f. front( ) );
}
catch( context::undeclaredidentifier ui)
{
std::cout << ui ;
exit(0);
}

if ( Formula_Declaration1 -> label. size( ) > 0 )
cont. assumeformula( Formula_Declaration1 -> label. front( ),
Formula_Declaration1 -> f. front( ),
false );
else
cont. assumeformula( Formula_Declaration1 -> f. front( ),
false );

{ reduce( stack, position, tkn_Declaration, tkn_Declaration ); return; }

}


void reduction_22(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Assume_Defined_Predicate1 ) throw( refused )
{

#line 231 "checker.m"

{ reduce( stack, position, tkn_Declaration, tkn_Declaration ); return; }

}


void reduction_23(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Assume_Defined_Function1 ) throw( refused )
{

#line 232 "checker.m"

{ reduce( stack, position, tkn_Declaration, tkn_Declaration ); return; }

}


void reduction_24(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator FUNCTION1,
   std::list< token > :: iterator IDENTIFIER2,
   std::list< token > :: iterator COLON3,
   std::list< token > :: iterator UNSIGNED4 ) throw( refused )
{

#line 239 "checker.m"


token t = tkn_Function_Declaration ;

t. d. push_front( declaration::make_funcdecl(IDENTIFIER2 -> id. front( ),
UNSIGNED4 -> uint. front( )));

{ reduce( stack, position, tkn_Function_Declaration, t ); return; }
{ reduce( stack, position, tkn_Function_Declaration, tkn_Function_Declaration ); return; }

}


void reduction_25(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator PREDICATE1,
   std::list< token > :: iterator IDENTIFIER2,
   std::list< token > :: iterator COLON3,
   std::list< token > :: iterator UNSIGNED4 ) throw( refused )
{

#line 250 "checker.m"


token t = tkn_Predicate_Declaration ;

t. d. push_front( declaration::make_preddecl( IDENTIFIER2 -> id. front( ),
UNSIGNED4 -> uint. front( )));
{ reduce( stack, position, tkn_Predicate_Declaration, t ); return; }
{ reduce( stack, position, tkn_Predicate_Declaration, tkn_Predicate_Declaration ); return; }

}


void reduction_26(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator FORMULA1,
   std::list< token > :: iterator Labeled_Formula2 ) throw( refused )
{

#line 262 "checker.m"


Labeled_Formula2 -> type = tkn_Formula_Declaration;

{ reduce( stack, position, tkn_Formula_Declaration, Labeled_Formula2 ); return; }
{ reduce( stack, position, tkn_Formula_Declaration, tkn_Formula_Declaration ); return; }

}


void reduction_27(
   std::list< token > & stack,
   context& cont, 
   std::list< token > :: iterator position,
   std::list< token > :: iterator PREDICATE1,
   std::list< token > :: iterator IDENTIFIER2,
   std::list< token > :: iterator COLONEQ3,
   std::list< token > :: iterator Lambda_Bound_Vars4,
   std::list< token > :: iterator Labeled_Formula5 ) throw( refused )
{

#line 271 "checker.m"


predicatevalue predval( Lambda_Bound_Vars4 -> idents ,
Labeled_Formula5 -> f. front( ));
try
{
cont. checkdeclarations( predval );
}
catch( context::undeclaredidentifier ui)
{
std::cout << ui ;
exit(0);
}

if ( Labeled_Formula5 -> label. size( ) > 0)
cont. definepredicate( IDENTIFIER2 -> id. front( ) ,
Lambda_Bound_Vars4 -> idents. size( ),
false,
Labeled_Formula5 -> label. front( ),
predval);
else
cont. definepredicate( IDENTIFIER2 -> id. front( ),
Lambda_Bound_Vars4 -> idents. size( ) ,
false,
predval);


{ reduce( stack, position, tkn_Assume_Defined_Predicate, tkn_Assume_Defined_Predicate ); return; }

}


void reduction_28(
   std::list< token > & stack,
   context& cont, 
   std::list< token > :: iterator position,
   std::list< token > :: iterator FUNCTION1,
   std::list< token > :: iterator IDENTIFIER2,
   std::list< token > :: iterator COLONEQ3,
   std::list< token > :: iterator Lambda_Bound_Vars4,
   std::list< token > :: iterator Labeled_Term5 ) throw( refused )
{

#line 300 "checker.m"


functionvalue fval( Lambda_Bound_Vars4 -> idents,
Labeled_Term5 -> t. front( ));
try
{
cont. checkdeclarations( fval );
}
catch( context::undeclaredidentifier ui)
{
std::cout << ui ;
exit(0);
}
if ( Labeled_Term5 -> label. size( ) > 0)
cont. definefunction( IDENTIFIER2 -> id. front( ),
Lambda_Bound_Vars4 -> idents. size( ),
false,
Labeled_Term5 -> label. front( ),
fval);
else
cont. definefunction( IDENTIFIER2 -> id. front( ),
Lambda_Bound_Vars4 -> idents. size( ),
false,
fval);

{ reduce( stack, position, tkn_Assume_Defined_Function, tkn_Assume_Defined_Function ); return; }

}


void reduction_29(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator DEFINE1,
   std::list< token > :: iterator Define_Predicate2 ) throw( refused )
{

#line 330 "checker.m"

{ reduce( stack, position, tkn_Permanent_Definition, tkn_Permanent_Definition ); return; }

}


void reduction_30(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator DEFINE1,
   std::list< token > :: iterator Define_Function_byPred2 ) throw( refused )
{

#line 331 "checker.m"

{ reduce( stack, position, tkn_Permanent_Definition, tkn_Permanent_Definition ); return; }

}


void reduction_31(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator DEFINE1,
   std::list< token > :: iterator Define_Function_byTerm2 ) throw( refused )
{

#line 332 "checker.m"

{ reduce( stack, position, tkn_Permanent_Definition, tkn_Permanent_Definition ); return; }

}


void reduction_32(
   std::list< token > & stack,
   context& cont, 
   std::list< token > :: iterator position,
   std::list< token > :: iterator PREDICATE1,
   std::list< token > :: iterator IDENTIFIER2,
   std::list< token > :: iterator BY3,
   std::list< token > :: iterator Lambda_Bound_Vars4,
   std::list< token > :: iterator Labeled_Formula5 ) throw( refused )
{

#line 339 "checker.m"


predicatevalue predval( Lambda_Bound_Vars4 -> idents ,
Labeled_Formula5 -> f. front( ));
try
{
cont. checkdeclarations( predval );
}
catch( context::undeclaredidentifier ui)
{
std::cout << ui ;
exit(0);
}
if ( Labeled_Formula5 -> label. size( ) > 0)
cont. definepredicate( IDENTIFIER2 -> id. front( ) ,
Lambda_Bound_Vars4 -> idents. size( ),
true,
Labeled_Formula5 -> label. front( ),
predval);
else
cont. definepredicate( IDENTIFIER2 -> id. front( ),
Lambda_Bound_Vars4 -> idents. size( ) ,
true,
predval);


{ reduce( stack, position, tkn_Define_Predicate, tkn_Define_Predicate ); return; }

}


void reduction_33(
   std::list< token > & stack,
   context& cont, 
   prover& pr, 
   std::list< token > :: iterator position,
   std::list< token > :: iterator FUNCTION1,
   std::list< token > :: iterator IDENTIFIER2,
   std::list< token > :: iterator INDIRECTLY3,
   std::list< token > :: iterator BY4,
   std::list< token > :: iterator Lambda_Bound_Vars5,
   std::list< token > :: iterator Labeled_Formula6,
   std::list< token > :: iterator EXISTENCE7,
   std::list< token > :: iterator References8,
   std::list< token > :: iterator UNIQUENESS9,
   std::list< token > :: iterator References10 ) throw( refused )
{

#line 367 "checker.m"


predicatevalue predval( Lambda_Bound_Vars5 -> idents ,
Labeled_Formula6 -> f. front( ));
try
{
cont. checkdeclarations( predval );
}
catch( context::undeclaredidentifier ui)
{
std::cout << ui ;
exit(0);
}
std::list< formula > existence, uniqueness;

existence = References8 -> f;
uniqueness = References10 -> f;

if ( ( existence. size( ) > 0) || ( uniqueness. size( ) > 0))
{


provergoal goal_existence( std::list< formula> :: list( ),
existence,
cont. make_existence( predval));

provergoal goal_uniqueness( std::list< formula> :: list( ),
uniqueness,
cont. make_uniqueness( predval));

try
{
if ( ! pr. trytoprove( goal_existence))
{
std::cout << " existence proof failed " << goal_existence;
exit(0);
}
}
catch( notfirstorder nfof)
{
std::cout << nfof;
exit(0);
}
catch( prover::readerror re)
{
std::cout << re;
exit(0);
}
catch( prover::writeerror we)
{
std::cout << we;
exit(0);
}

try
{
if ( !pr. trytoprove( goal_uniqueness))
{
std::cout << " uniqueness proof failed " << goal_uniqueness;
exit(0);
}
}
catch( notfirstorder nfof)
{
std::cout << nfof;
exit(0);
}
catch( prover::readerror re)
{
std::cout << re;
exit(0);
}
catch( prover::writeerror we)
{
std::cout << we;
exit(0);
}

}

if ( Labeled_Formula6 -> label. size( ) > 0)
cont. definefunction( IDENTIFIER2 -> id. front ( ),
Lambda_Bound_Vars5 -> idents. size( ) -1,
Labeled_Formula6 -> label. front( ),
predval,
std::string("Proven by ") + pr. name,
std::string(""));
else
cont. definefunction( IDENTIFIER2 -> id. front( ),
Lambda_Bound_Vars5 -> idents. size( ) -1,
predval,
std::string("Proven by ") + pr. name,
std::string(""));

{ reduce( stack, position, tkn_Define_Function_byPred, tkn_Define_Function_byPred ); return; }

}


void reduction_34(
   std::list< token > & stack,
   context& cont, 
   std::list< token > :: iterator position,
   std::list< token > :: iterator FUNCTION1,
   std::list< token > :: iterator IDENTIFIER2,
   std::list< token > :: iterator BY3,
   std::list< token > :: iterator Lambda_Bound_Vars4,
   std::list< token > :: iterator Labeled_Term5 ) throw( refused )
{

#line 463 "checker.m"


functionvalue fval( Lambda_Bound_Vars4 -> idents,
Labeled_Term5 -> t. front( ));
try
{
cont. checkdeclarations( fval );
}
catch( context::undeclaredidentifier ui)
{
std::cout << ui ;
exit(0);
}
if ( Labeled_Term5 -> label. size( ) > 0)
cont. definefunction( IDENTIFIER2 -> id. front( ),
Lambda_Bound_Vars4 -> idents. size( ),
true,
Labeled_Term5 -> label. front( ),
fval);
else
cont. definefunction( IDENTIFIER2 -> id. front( ),
Lambda_Bound_Vars4 -> idents. size( ),
true,
fval);

{ reduce( stack, position, tkn_Define_Function_byTerm, tkn_Define_Function_byTerm ); return; }

}


void reduction_35(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Reference1,
   std::list< token > :: iterator COMMA2,
   std::list< token > :: iterator References3 ) throw( refused )
{

#line 510 "checker.m"


References3 -> f. push_front( Reference1 -> f. front ( ));

{ reduce( stack, position, tkn_References, References3 ); return; }

{ reduce( stack, position, tkn_References, tkn_References ); return; }

}


void reduction_36(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Reference1 ) throw( refused )
{

#line 516 "checker.m"


Reference1 -> type = tkn_References;

{ reduce( stack, position, tkn_References, Reference1 ); return; }
{ reduce( stack, position, tkn_References, tkn_References ); return; }

}


void reduction_37(
   std::list< token > & stack,
   std::list< token > :: iterator position ) throw( refused )
{

#line 521 "checker.m"


token References_tkn = tkn_References;
{ reduce( stack, position, tkn_References, References_tkn ); return; }
{ reduce( stack, position, tkn_References, tkn_References ); return; }

}


void reduction_38(
   std::list< token > & stack,
   context& cont, 
   std::list< token > :: iterator position,
   std::list< token > :: iterator MINUS1,
   std::list< token > :: iterator UNSIGNED2 ) throw( refused )
{

#line 530 "checker.m"


std::vector<context::property> :: const_iterator prp;

prp = cont. getformula( - UNSIGNED2 -> uint. front( ) );
if ( prp == cont. end( ) )
{
std::cout << " Invalid reference: -" << UNSIGNED2 ->uint. front( ) << "\n";
exit(0);
}

isvalid( cont, prp );


token Reference_tkn = tkn_Reference;
Reference_tkn. f. push_back(  prp -> getformula( ));

{ reduce( stack, position, tkn_Reference, Reference_tkn ); return; }

{ reduce( stack, position, tkn_Reference, tkn_Reference ); return; }

}


void reduction_39(
   std::list< token > & stack,
   context& cont, 
   std::list< token > :: iterator position,
   std::list< token > :: iterator IDENTIFIER1 ) throw( refused )
{

#line 549 "checker.m"


std::vector<context::property> :: const_iterator prp;

prp = cont. getformula( IDENTIFIER1 -> id. front( ), 0 );
if ( prp == cont. end( ) )
{
std::cout << " Invalid reference: " << IDENTIFIER1 ->id. front( ) << "\n";
exit(0);
}

isvalid( cont, prp );

token Reference_tkn = tkn_Reference;
Reference_tkn. f. push_back(  prp -> getformula( ));

{ reduce( stack, position, tkn_Reference, Reference_tkn ); return; }


{ reduce( stack, position, tkn_Reference, tkn_Reference ); return; }

}


void reduction_40(
   std::list< token > & stack,
   context& cont, 
   std::list< token > :: iterator position,
   std::list< token > :: iterator IDENTIFIER1,
   std::list< token > :: iterator PLUS2,
   std::list< token > :: iterator UNSIGNED3 ) throw( refused )
{

#line 568 "checker.m"


std::vector<context::property> :: const_iterator prp;

prp = cont. getformula( IDENTIFIER1 -> id. front( ),
UNSIGNED3 -> uint. front( ) );
if ( prp == cont. end( ) )
{
std::cout << "Invalid reference: " << IDENTIFIER1 ->id. front( ) <<" + "
<< UNSIGNED3 -> uint. front( ) << "\n";
exit(0);
}

isvalid( cont, prp );

token Reference_tkn = tkn_Reference;
Reference_tkn. f. push_back(  prp -> getformula( ));

{ reduce( stack, position, tkn_Reference, Reference_tkn ); return; }

{ reduce( stack, position, tkn_Reference, tkn_Reference ); return; }

}


void reduction_41(
   std::list< token > & stack,
   context& cont, 
   std::list< token > :: iterator position,
   std::list< token > :: iterator IDENTIFIER1,
   std::list< token > :: iterator MINUS2,
   std::list< token > :: iterator UNSIGNED3 ) throw( refused )
{

#line 588 "checker.m"


std::vector<context::property> :: const_iterator prp;

prp = cont. getformula( IDENTIFIER1 -> id. front( ),
- UNSIGNED3 -> uint. front( ));

if ( prp == cont. end( ) )
{
std::cout << "Invalid reference: " << IDENTIFIER1 ->id. front( ) <<" - "
<< UNSIGNED3 -> uint. front( ) << "\n";
exit(0);
}
isvalid( cont, prp );

token Reference_tkn = tkn_Reference;
Reference_tkn. f. push_back(  prp -> getformula( ));

{ reduce( stack, position, tkn_Reference, Reference_tkn ); return; }

{ reduce( stack, position, tkn_Reference, tkn_Reference ); return; }

}


void reduction_42(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Reference1,
   std::list< token > :: iterator LSQBR2,
   std::list< token > :: iterator Instantiations3,
   std::list< token > :: iterator RSQBR4 ) throw( refused )
{

#line 608 "checker.m"


formula sf = Reference1 -> f. front( );
substitution insts = Instantiations3 -> subst. front( );
std::list< declaration> newvars;

// As long as sf is universally, quantified, remove the variables which occur in
// the domain of the substitution and put the others in newvars.

while ( sf. getoperator( ) == fol_forall)
{

for( std::list< declaration>:: const_iterator it = sf. variables_begin( );
it != sf. variables_end( );
it ++ )
{
if ( ! insts. indomain( *it))
newvars. push_back( *it);
}

sf = *sf. subformulas_begin( );
}


formula result = sf;
result = insts. apply_on(  sf) ;
if ( newvars. size( ) > 0)
result = formula::make_schematicforall( newvars, result);

token Reference_tkn = tkn_Reference;
Reference_tkn. f. push_back( result );

{ reduce( stack, position, tkn_Reference, Reference_tkn ); return; }

{ reduce( stack, position, tkn_Reference, tkn_Reference ); return; }

}


void reduction_43(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator MP1,
   std::list< token > :: iterator LPAR2,
   std::list< token > :: iterator Reference3,
   std::list< token > :: iterator COMMA4,
   std::list< token > :: iterator Reference5,
   std::list< token > :: iterator RPAR6 ) throw( refused )
{

#line 642 "checker.m"


if ( Reference5 -> f. front( ). getoperator( ) != fol_implies )
{
std::cout << " Second reference must be an implication.\n";
std::cout << "Reference: " << Reference5 -> f. front( ) << "\n";
exit(0);
}

formula imp1 = * ( Reference5 -> f. front( ). subformulas_begin( ));
formula imp2 = * (++ ( Reference5 -> f. front( ). subformulas_begin( )));

if ( ! substitution::alphaequal( imp1, Reference3 ->f. front( ) ))
{
std::cout << " Formulas: " << imp1 << " and " << Reference3 -> f. front( )
<< " are not alpha equivalent";
exit(0);
}

token Reference_tkn = tkn_Reference;
Reference_tkn. f. push_back ( imp2 );

{ reduce( stack, position, tkn_Reference, Reference_tkn ); return; }

{ reduce( stack, position, tkn_Reference, tkn_Reference ); return; }

}


void reduction_44(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator LPAR1,
   std::list< token > :: iterator Reference2,
   std::list< token > :: iterator RPAR3 ) throw( refused )
{

#line 666 "checker.m"


{ reduce( stack, position, tkn_Reference, Reference2 ); return; }
{ reduce( stack, position, tkn_Reference, tkn_Reference ); return; }

}


void reduction_45(
   std::list< token > & stack,
   context& cont, 
   std::list< token > :: iterator position,
   std::list< token > :: iterator IDENTIFIER1,
   std::list< token > :: iterator COLONEQ2,
   std::list< token > :: iterator FUNCTION3,
   std::list< token > :: iterator Lambda_Bound_Vars4,
   std::list< token > :: iterator Term5,
   std::list< token > :: iterator COMMA6,
   std::list< token > :: iterator Instantiations7 ) throw( refused )
{

#line 676 "checker.m"


try
{
cont. checkdeclarations( functionvalue( Lambda_Bound_Vars4 ->idents, Term5 -> t. front( ) ));
}
catch( context::undeclaredidentifier ui)
{
std::cout << ui ;
exit(0);
}
Instantiations7 -> subst. front( ). assign_function(
IDENTIFIER1 -> id. front( ) ,
Lambda_Bound_Vars4 -> idents. size( ),
functionvalue( Lambda_Bound_Vars4 -> idents, Term5 -> t. front( ) ) );

{ reduce( stack, position, tkn_Instantiations, Instantiations7 ); return; }

{ reduce( stack, position, tkn_Instantiations, tkn_Instantiations ); return; }

}


void reduction_46(
   std::list< token > & stack,
   context& cont, 
   std::list< token > :: iterator position,
   std::list< token > :: iterator IDENTIFIER1,
   std::list< token > :: iterator COLONEQ2,
   std::list< token > :: iterator PREDICATE3,
   std::list< token > :: iterator Lambda_Bound_Vars4,
   std::list< token > :: iterator Formula5,
   std::list< token > :: iterator COMMA6,
   std::list< token > :: iterator Instantiations7 ) throw( refused )
{

#line 694 "checker.m"


try
{
cont. checkdeclarations( predicatevalue( Lambda_Bound_Vars4 ->idents, Formula5 -> f. front( ) ));
}
catch( context::undeclaredidentifier ui)
{
std::cout << ui ;
exit(0);
}
Instantiations7 -> subst. front( ). assign_predicate(
IDENTIFIER1 -> id. front( ) ,
Lambda_Bound_Vars4 -> idents. size( ),
predicatevalue( Lambda_Bound_Vars4 -> idents, Formula5 -> f. front( ) ) );

{ reduce( stack, position, tkn_Instantiations, Instantiations7 ); return; }


{ reduce( stack, position, tkn_Instantiations, tkn_Instantiations ); return; }

}


void reduction_47(
   std::list< token > & stack,
   context& cont, 
   std::list< token > :: iterator position,
   std::list< token > :: iterator IDENTIFIER1,
   std::list< token > :: iterator COLONEQ2,
   std::list< token > :: iterator FUNCTION3,
   std::list< token > :: iterator Lambda_Bound_Vars4,
   std::list< token > :: iterator Term5 ) throw( refused )
{

#line 713 "checker.m"


try
{
cont. checkdeclarations( functionvalue( Lambda_Bound_Vars4 ->idents, Term5 -> t. front( ) ));
}
catch( context::undeclaredidentifier ui)
{
std::cout << ui ;
exit(0);
}
token Inst_tkn = tkn_Instantiations;
substitution s;
s . assign_function(
IDENTIFIER1 -> id. front( ),
Lambda_Bound_Vars4 -> idents. size( ),
functionvalue( Lambda_Bound_Vars4 -> idents, Term5 -> t. front( ) ) );

Inst_tkn. subst. push_back( s );

{ reduce( stack, position, tkn_Instantiations, Inst_tkn ); return; }

{ reduce( stack, position, tkn_Instantiations, tkn_Instantiations ); return; }

}


void reduction_48(
   std::list< token > & stack,
   context& cont, 
   std::list< token > :: iterator position,
   std::list< token > :: iterator IDENTIFIER1,
   std::list< token > :: iterator COLONEQ2,
   std::list< token > :: iterator PREDICATE3,
   std::list< token > :: iterator Lambda_Bound_Vars4,
   std::list< token > :: iterator Formula5 ) throw( refused )
{

#line 735 "checker.m"


try
{
cont. checkdeclarations( predicatevalue( Lambda_Bound_Vars4 ->idents, Formula5 -> f. front( ) ));
}
catch( context::undeclaredidentifier ui)
{
std::cout << ui ;
exit(0);
}
token Inst_tkn = tkn_Instantiations;
substitution s;
s. assign_predicate(
IDENTIFIER1 -> id. front( ),
Lambda_Bound_Vars4 -> idents. size( ),
predicatevalue( Lambda_Bound_Vars4 -> idents, Formula5 -> f. front( ) ) );
Inst_tkn. subst. push_back( s );

{ reduce( stack, position, tkn_Instantiations, Inst_tkn ); return; }
{ reduce( stack, position, tkn_Instantiations, tkn_Instantiations ); return; }

}


void reduction_49(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator LAMBDA1,
   std::list< token > :: iterator Ident_list2 ) throw( refused )
{

#line 761 "checker.m"


Ident_list2 -> type = tkn_Lambda_Bound_Vars;

{ reduce( stack, position, tkn_Lambda_Bound_Vars, Ident_list2 ); return; }

{ reduce( stack, position, tkn_Lambda_Bound_Vars, tkn_Lambda_Bound_Vars ); return; }

}


void reduction_50(
   std::list< token > & stack,
   std::list< token > :: iterator position ) throw( refused )
{

#line 767 "checker.m"


token Lambda_Bound_Vars_tkn = tkn_Lambda_Bound_Vars;

{ reduce( stack, position, tkn_Lambda_Bound_Vars, Lambda_Bound_Vars_tkn ); return; }
{ reduce( stack, position, tkn_Lambda_Bound_Vars, tkn_Lambda_Bound_Vars ); return; }

}


void reduction_51(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator IDENTIFIER1,
   std::list< token > :: iterator COMMA2,
   std::list< token > :: iterator Ident_list3 ) throw( refused )
{

#line 778 "checker.m"


Ident_list3 -> idents. push_front( IDENTIFIER1 -> id. front( ));

{ reduce( stack, position, tkn_Ident_list, Ident_list3 ); return; }

{ reduce( stack, position, tkn_Ident_list, tkn_Ident_list ); return; }

}


void reduction_52(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator IDENTIFIER1 ) throw( refused )
{

#line 784 "checker.m"


token Ident_list_tkn = tkn_Ident_list;

Ident_list_tkn. idents. push_front( IDENTIFIER1 -> id. front( ));

{ reduce( stack, position, tkn_Ident_list, Ident_list_tkn ); return; }
{ reduce( stack, position, tkn_Ident_list, tkn_Ident_list ); return; }

}


void reduction_53(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Function_Declaration1 ) throw( refused )
{

#line 875 "checker.m"


Function_Declaration1 -> type = tkn_Bound_list;

{ reduce( stack, position, tkn_Bound_list, Function_Declaration1 ); return; }

{ reduce( stack, position, tkn_Bound_list, tkn_Bound_list ); return; }

}


void reduction_54(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Predicate_Declaration1 ) throw( refused )
{

#line 881 "checker.m"


Predicate_Declaration1 -> type = tkn_Bound_list;

{ reduce( stack, position, tkn_Bound_list, Predicate_Declaration1 ); return; }


{ reduce( stack, position, tkn_Bound_list, tkn_Bound_list ); return; }

}


void reduction_55(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Function_Declaration1,
   std::list< token > :: iterator COMMA2,
   std::list< token > :: iterator Bound_list3 ) throw( refused )
{

#line 888 "checker.m"


Bound_list3 -> d. push_front ( Function_Declaration1 -> d. front( ) );

{ reduce( stack, position, tkn_Bound_list, Bound_list3 ); return; }

{ reduce( stack, position, tkn_Bound_list, tkn_Bound_list ); return; }

}


void reduction_56(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Predicate_Declaration1,
   std::list< token > :: iterator COMMA2,
   std::list< token > :: iterator Bound_list3 ) throw( refused )
{

#line 894 "checker.m"


Bound_list3 -> d. push_front ( Predicate_Declaration1 -> d. front( ) );

{ reduce( stack, position, tkn_Bound_list, Bound_list3 ); return; }

{ reduce( stack, position, tkn_Bound_list, tkn_Bound_list ); return; }

}


void reduction_57(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator IDENTIFIER1 ) throw( refused )
{

#line 900 "checker.m"


token t = tkn_Bound_list;
t. d. push_back( declaration::make_funcdecl( IDENTIFIER1 -> id. front( ), 0));

{ reduce( stack, position, tkn_Bound_list, t ); return; }

{ reduce( stack, position, tkn_Bound_list, tkn_Bound_list ); return; }

}


void reduction_58(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator IDENTIFIER1,
   std::list< token > :: iterator COMMA2,
   std::list< token > :: iterator Bound_list3 ) throw( refused )
{

#line 907 "checker.m"


Bound_list3 -> d. push_front( declaration::make_funcdecl(
IDENTIFIER1 -> id. front( ),
0));

{ reduce( stack, position, tkn_Bound_list, Bound_list3 ); return; }
{ reduce( stack, position, tkn_Bound_list, tkn_Bound_list ); return; }

}


void reduction_59(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator LSQBR1,
   std::list< token > :: iterator Bound_list2,
   std::list< token > :: iterator RSQBR3 ) throw( refused )
{

#line 920 "checker.m"


Bound_list2 -> type = tkn_QForall;

{ reduce( stack, position, tkn_QForall, Bound_list2 ); return; }
{ reduce( stack, position, tkn_QForall, tkn_QForall ); return; }

}


void reduction_60(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator LANGBR1,
   std::list< token > :: iterator Bound_list2,
   std::list< token > :: iterator RANGBR3 ) throw( refused )
{

#line 929 "checker.m"


Bound_list2 -> type = tkn_QExists;

{ reduce( stack, position, tkn_QExists, Bound_list2 ); return; }
{ reduce( stack, position, tkn_QExists, tkn_QExists ); return; }

}


void reduction_61(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator IDENTIFIER1,
   std::list< token > :: iterator COLON2,
   std::list< token > :: iterator Formula3 ) throw( refused )
{

#line 941 "checker.m"


Formula3 -> type = tkn_Labeled_Formula;
Formula3 -> label = IDENTIFIER1 -> id;

{ reduce( stack, position, tkn_Labeled_Formula, Formula3 ); return; }

{ reduce( stack, position, tkn_Labeled_Formula, tkn_Labeled_Formula ); return; }

}


void reduction_62(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Formula1 ) throw( refused )
{

#line 948 "checker.m"


Formula1 -> type = tkn_Labeled_Formula;

{ reduce( stack, position, tkn_Labeled_Formula, Formula1 ); return; }
{ reduce( stack, position, tkn_Labeled_Formula, tkn_Labeled_Formula ); return; }

}


void reduction_63(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Formula1,
   std::list< token > :: iterator AND2,
   std::list< token > :: iterator Formula3,
   const std::list< token > & lookahead ) throw( refused )
{

#line 964 "checker.m"


if ( ! lookahead. size( ) || shouldreduce( *AND2, lookahead. front( ) ))
{
token formula_tkn = tkn_Formula;

formula_tkn. f. push_back( formula::make_and (
Formula1 -> f. front( ),
Formula3 -> f. front( )));

{ reduce( stack, position, tkn_Formula, formula_tkn ); return; }
}
else
throw refused::refused( );


{ reduce( stack, position, tkn_Formula, tkn_Formula ); return; }

}


void reduction_64(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Formula1,
   std::list< token > :: iterator OR2,
   std::list< token > :: iterator Formula3,
   const std::list< token > & lookahead ) throw( refused )
{

#line 980 "checker.m"


if ( ! lookahead. size( ) || shouldreduce( *OR2, lookahead. front( ) ))
{
token formula_tkn = tkn_Formula;

formula_tkn. f. push_back( formula::make_or (
Formula1 -> f. front( ),
Formula3 -> f. front( )));

{ reduce( stack, position, tkn_Formula, formula_tkn ); return; }
}
else
throw refused::refused( );


{ reduce( stack, position, tkn_Formula, tkn_Formula ); return; }

}


void reduction_65(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Formula1,
   std::list< token > :: iterator IMPLIES2,
   std::list< token > :: iterator Formula3,
   const std::list< token > & lookahead ) throw( refused )
{

#line 996 "checker.m"


if ( ! lookahead. size( ) || shouldreduce( *IMPLIES2, lookahead. front( ) ))
{
token formula_tkn = tkn_Formula;

formula_tkn. f. push_back( formula::make_implies (
Formula1 -> f. front( ),
Formula3 -> f. front( )));

{ reduce( stack, position, tkn_Formula, formula_tkn ); return; }


}
else
throw refused::refused( );


{ reduce( stack, position, tkn_Formula, tkn_Formula ); return; }

}


void reduction_66(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Formula1,
   std::list< token > :: iterator EQUIV2,
   std::list< token > :: iterator Formula3,
   const std::list< token > & lookahead ) throw( refused )
{

#line 1014 "checker.m"


if ( ! lookahead. size( ) || shouldreduce( *EQUIV2, lookahead. front( ) ))
{
token formula_tkn = tkn_Formula;

formula_tkn. f. push_back( formula::make_equiv (
Formula1 -> f. front( ),
Formula3 -> f. front( )));

{ reduce( stack, position, tkn_Formula, formula_tkn ); return; }
}
else
throw refused::refused( );

{ reduce( stack, position, tkn_Formula, tkn_Formula ); return; }

}


void reduction_67(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator QExists1,
   std::list< token > :: iterator Formula2,
   const std::list< token > & lookahead ) throw( refused )
{

#line 1029 "checker.m"


if ( ! lookahead. size( ) || shouldreduce( *QExists1, lookahead. front( )))
{
//TODO: check for schematic formula? No.

token formula_tkn = tkn_Formula;

formula_tkn. f. push_back( formula::make_schematicexists(
QExists1 -> d,
Formula2 -> f. front( ) ));

{ reduce( stack, position, tkn_Formula, formula_tkn ); return; }
}
else
throw refused::refused( );
{ reduce( stack, position, tkn_Formula, tkn_Formula ); return; }

}


void reduction_68(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator QForall1,
   std::list< token > :: iterator Formula2,
   const std::list< token > & lookahead ) throw( refused )
{

#line 1045 "checker.m"


if ( ! lookahead. size( ) || shouldreduce( *QForall1, lookahead. front( )) )
{
//TODO: check for schematic formula? No.
token formula_tkn = tkn_Formula;

formula_tkn. f. push_back( formula::make_schematicforall(
QForall1 -> d,
Formula2 -> f. front( ) ));

{ reduce( stack, position, tkn_Formula, formula_tkn ); return; }
}
else
throw refused::refused( );
{ reduce( stack, position, tkn_Formula, tkn_Formula ); return; }

}


void reduction_69(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator NOT1,
   std::list< token > :: iterator Formula2 ) throw( refused )
{

#line 1060 "checker.m"


token formula_tkn = tkn_Formula;

formula_tkn. f. push_back( formula::make_not( Formula2 -> f. front( ) ));

{ reduce( stack, position, tkn_Formula, formula_tkn ); return; }

{ reduce( stack, position, tkn_Formula, tkn_Formula ); return; }

}


void reduction_70(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator LPAR1,
   std::list< token > :: iterator Formula2,
   std::list< token > :: iterator RPAR3 ) throw( refused )
{

#line 1068 "checker.m"


{ reduce( stack, position, tkn_Formula, Formula2 ); return; }

{ reduce( stack, position, tkn_Formula, tkn_Formula ); return; }

}


void reduction_71(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator FALSE1 ) throw( refused )
{

#line 1072 "checker.m"


token formula_tkn = tkn_Formula;

formula_tkn. f. push_back( formula::make_false( ) );

{ reduce( stack, position, tkn_Formula, formula_tkn ); return; }
{ reduce( stack, position, tkn_Formula, tkn_Formula ); return; }

}


void reduction_72(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator TRUE1 ) throw( refused )
{

#line 1079 "checker.m"


token formula_tkn = tkn_Formula;

formula_tkn. f. push_back( formula::make_true( ) );

{ reduce( stack, position, tkn_Formula, formula_tkn ); return; }


/*WISH: more readable error messages. Some errors are reported during execution of parser by ASSERT. */
/*(for example unsatisfied constraints). They cannot be reported during compile time.*/
{ reduce( stack, position, tkn_Formula, tkn_Formula ); return; }

}


void reduction_73(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Atom1 ) throw( refused )
{

#line 1090 "checker.m"


Atom1 -> type = tkn_Formula;

{ reduce( stack, position, tkn_Formula, Atom1 ); return; }

{ reduce( stack, position, tkn_Formula, tkn_Formula ); return; }

}


void reduction_74(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Term1,
   std::list< token > :: iterator EQ2,
   std::list< token > :: iterator Term3 ) throw( refused )
{

#line 1096 "checker.m"


token t = tkn_Formula;

t. f. push_back( formula::make_equals( Term1 -> t. front( ),
Term3 -> t. front( ) ));

{ reduce( stack, position, tkn_Formula, t ); return; }
{ reduce( stack, position, tkn_Formula, tkn_Formula ); return; }

}


void reduction_75(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator IDENTIFIER1,
   std::list< token > :: iterator LPAR2,
   std::list< token > :: iterator Term_list3,
   std::list< token > :: iterator RPAR4 ) throw( refused )
{

#line 1111 "checker.m"


token Atom_tkn = tkn_Atom;
Atom_tkn. f. push_front( formula::make_atom( IDENTIFIER1 -> id. front( ),
Term_list3 -> t ));

{ reduce( stack, position, tkn_Atom, Atom_tkn ); return; }

{ reduce( stack, position, tkn_Atom, tkn_Atom ); return; }

}


void reduction_76(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator IDENTIFIER1 ) throw( refused )
{

#line 1119 "checker.m"


token Atom_tkn = tkn_Atom;
std::list< term > empty;
Atom_tkn. f. push_front( formula::make_atom( IDENTIFIER1 -> id. front( ),
empty ));


{ reduce( stack, position, tkn_Atom, Atom_tkn ); return; }
{ reduce( stack, position, tkn_Atom, tkn_Atom ); return; }

}


void reduction_77(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator IDENTIFIER1,
   std::list< token > :: iterator COLON2,
   std::list< token > :: iterator Term3 ) throw( refused )
{

#line 1136 "checker.m"


Term3 -> type = tkn_Labeled_Term;
Term3 -> label. push_front( IDENTIFIER1 -> id. front( ));

{ reduce( stack, position, tkn_Labeled_Term, Term3 ); return; }

{ reduce( stack, position, tkn_Labeled_Term, tkn_Labeled_Term ); return; }

}


void reduction_78(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Term1 ) throw( refused )
{

#line 1143 "checker.m"


Term1 -> type = tkn_Labeled_Term;
{ reduce( stack, position, tkn_Labeled_Term, Term1 ); return; }
{ reduce( stack, position, tkn_Labeled_Term, tkn_Labeled_Term ); return; }

}


void reduction_79(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator IDENTIFIER1,
   std::list< token > :: iterator LPAR2,
   std::list< token > :: iterator Term_list3,
   std::list< token > :: iterator RPAR4 ) throw( refused )
{

#line 1152 "checker.m"


token Term_tkn = tkn_Term;
Term_tkn. t. push_front( term( IDENTIFIER1 -> id. front( ), Term_list3 -> t ));

{ reduce( stack, position, tkn_Term, Term_tkn ); return; }

{ reduce( stack, position, tkn_Term, tkn_Term ); return; }

}


void reduction_80(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator IDENTIFIER1 ) throw( refused )
{

#line 1159 "checker.m"


token Term_tkn = tkn_Term;
std::list< term > empty;
Term_tkn. t. push_front( term( IDENTIFIER1 -> id. front( ),
empty ));
{ reduce( stack, position, tkn_Term, Term_tkn ); return; }
{ reduce( stack, position, tkn_Term, tkn_Term ); return; }

}


void reduction_81(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Term1,
   std::list< token > :: iterator COMMA2,
   std::list< token > :: iterator Term_list3 ) throw( refused )
{

#line 1174 "checker.m"


Term_list3 -> t. push_front( Term1 -> t. front( ) );

{ reduce( stack, position, tkn_Term_list, Term_list3 ); return; }

{ reduce( stack, position, tkn_Term_list, tkn_Term_list ); return; }

}


void reduction_82(
   std::list< token > & stack,
   std::list< token > :: iterator position,
   std::list< token > :: iterator Term1 ) throw( refused )
{

#line 1180 "checker.m"


Term1 -> type = tkn_Term_list;

{ reduce( stack, position, tkn_Term_list, Term1 ); return; }
{ reduce( stack, position, tkn_Term_list, tkn_Term_list ); return; }

}





   
   // The return values are specified as follows: 
   // 
   //                 0 : error.
   //        10000 + X  : push to state X.
   //        -10000 - X : Reduce rule X.
   // 
   // The returned list contains a sequence of reductions, terminated 
   // by an error or a push. 
   //
   // We try to base our decision on lookahead. If more lookahead
   // is required, we extend lookahead by doing: 
   //    lookahead. push_back( read. scan( ));
   

   std::list< int > decideaction( unsigned int ss, reader& read )
   {
      std::list< int > result;

      unsigned int k = starts [ss];
      unsigned int defred = 0;
 
      while( true )
      {
         while( k == starts [ ss + 1 ] )
         {
            // This means that we reached the end.
            // If defaults [ss] != ss, we can continue looking in another
            // state.

            if( defaults [ss] == ss )
            {
               if( defred == 0 )
                  result. push_back(0);
               else
               {
                  result. push_back( defred ); 
                  result. push_back(0);
               }
               return result; 
            }

            ss = defaults [ ss ];
            k = starts [ ss ]; 
         }
          
         if( parsetable [k] == tkn__defaultred )
         {
            ASSERT( parsetable [ k+1 ] < 0 && parsetable [ k+2 ] == 0 );
            ASSERT( defred == 0 );
            defred = parsetable [ k + 1 ];
            k += 3; 
         }
         else
         {
            if( read. lookahead. size( ) == 0 )
            {
               read. scan( );
               ASSERT( read. lookahead. size( ));
            }

            if( read. lookahead. size( ) &&
                read. lookahead. front( ). type == parsetable [k] )
            {
               ++ k; 
               while( parsetable [k] < 0 )
                  result. push_back( parsetable [ k ++ ] );
               result. push_back( parsetable [k] );
               return result;
            }
            
            ++ k;
            while( parsetable [k] < 0 )
               ++ k;
            ++ k; 
         }
      }
   }


   bool stateisempty( unsigned int ss )
   {
      return starts [ss] == starts [ss+1];
   }


   bool isstartlookahead( unsigned int entry, reader& read )
   { 
      ASSERT( read. lookahead. size( ));

      entry += 2;  
      while( entrypoints [ entry ] >= 0 )
      {
         if( entrypoints [ entry ] == read. lookahead. front( ). type )
            return true;
         ++ entry;
      }
      return false;
   }

}
 

// The reader must have the following features:
// It must have a field std::list< token > lookahead; 
// It must have a method void scan( ), which reads a token from somewhere
// and appends it to lookahead. scan( ) must always return a token,
// also when it reaches end of file, or when it is unable to read 
// input for some kind of reason. 
// It must have a method syntaxerror( ), which reports a syntax error
// to the user. 
// 
// The parser is called with the start symbol of the partial grammar
// that has to be parsed. 
// It uses the lookahead list of the reader for returning its value.
// In case of a successful parse, lookahead starts with the start
// symbol. A second symbol need not be present. If there is a second
// symbol, then it is the lookahead symbol of the original start symbol. 
// The parser will read the lookahead only when it is necessary for
// deciding.
// 
// When an error occurred, and the parser reached a lookahead symbol
// while attempting to recover, the lookahead list equals this 
// lookahead symbol. 
// If the parser gave up, because more than
// recoverlength symbols were read, it returns a list of length 1 
// containing a recover symbol. 

// Setting recoverlength = 0 ensures that the parser will not try to
// recover. 


void parser( reader& read,
      context & cont,
      prover & pr,
      unsigned int & bottom, tokentype start, unsigned int recoverlength )
//throw ( error )
{

   unsigned int errorcount = 0;
      // If errorcount > 0, then errors are not reported. 
      // Instead we assume that the previous recovery was not 
      // successful. 

   unsigned int entry = 0;
   while( entrypoints [ entry ] != -1 && entrypoints [ entry ] != start )
   {
      while( entrypoints [ entry ] != -1 )
         ++ entry;
      ++ entry;
   }

   if( entrypoints [ entry ] != start )
   {
      std::cout<< "could not find startsymbol " << start << "\n";
      ASSERT( false ); 
      exit(0);
   }

   std::list< unsigned int > states; 
   states. push_back( entrypoints [ entry + 1 ] );

   std::list< token > parsestack; 
 
   while( true ) 
   {
      ASSERT( states. size( ) == parsestack. size( ) + 1 );

#ifdef MAPH_DEBUG
      std::cout << "stack of states: "; 
      for( std::list< unsigned int > :: const_iterator
              p = states. begin( );
              p != states. end( );
              ++ p )
      {
         if( p != states. begin( ))
            std::cout << ", "; 
         std::cout << *p;
      }
      std::cout << "\n";

      std::cout << "stack of symbols: "; 
      for( std::list< token > :: const_iterator
              p = parsestack. begin( );
              p != parsestack. end( );
              ++ p )
      {
         if( p != parsestack. begin( ))
            std::cout << ", ";
         std::cout << *p;
      }
      std::cout << "\n";

      if( read. lookahead. size( ))
         std::cout << "lookahead: " << read. lookahead. front( ) << "\n";
#endif
      // We will check if we are in an accepting state. 
      // The parse stack must have size 1, and contain the 
      // start symbol of the grammar.

      if( parsestack. size( ) == 1 && 
          parsestack. front( ). type == entrypoints [ entry ] )
      {
         // This is a good start.
      
         // If we are in an empty state, we simply accept, and that's
         // the end of the story.

         if( stateisempty( states. back( )))
         {
            read. lookahead. splice( read. lookahead. begin( ),
                               parsestack, parsestack. begin( ));
            
            return;  
         }

         // Otherwise, we check whether lookahed is one of the 
         // lookahead symbols of the start symbol. 
                   
         if( read. lookahead. size( ) == 0 )
         {
            read. scan( );
            ASSERT( read. lookahead. size( ));
         }

         if( isstartlookahead( entry, read )) 
         {
            // This means that we accept. We move the start symbol
            // to the lookahead and quit.

            read. lookahead. splice( read. lookahead. begin( ),
                                     parsestack, parsestack. begin( ));
            return; 
         }
 
         // Otherwise we simply continue, and let things go their way.
         // This does not necessarily imply that there will be an error.
         //  It is also possible that the parser will continue.
      }
       
      std::list< int > actions = decideaction( states. back( ), read );

      // If we have reductions, we try to perform them:
      // If we manage to make a reduction, we clear actions,
      // so that we will come out of this loop:

      while( actions. size( ) > 1 ) 
      {
         ASSERT( actions. front( ) < 0 );
         unsigned int rule = - actions. front( ) - 10000;

#ifdef MAPH_DEBUG
         std::cout << "attempting to reduce rule " << rule << "\n";
#endif

         try
         {
            switch( rule ) 
            {
case 0:
   reduction_0( parsestack, parsestack. end( ) - 2, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 1:
   reduction_1( parsestack, parsestack. end( ) - 2, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 2:
   reduction_2( parsestack, parsestack. end( ) - 2, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 3:
   reduction_3( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 4:
   reduction_4( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 5:
   reduction_5( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 6:
   reduction_6( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 7:
   reduction_7( parsestack, parsestack. end( ) - 2, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 8:
   reduction_8( parsestack, parsestack. end( ) - 2, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 9:
   reduction_9( parsestack, parsestack. end( ) - 2, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 10:
   reduction_10( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 11:
   reduction_11( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 12:
   reduction_12( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 13:
   reduction_13( parsestack, cont, pr, parsestack. end( ) - 4, parsestack. end( ) - 4, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 14:
   reduction_14( parsestack, cont, bottom, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 15:
   reduction_15( parsestack, cont, bottom, parsestack. end( ) - 2, parsestack. end( ) - 2, parsestack. end( ) - 1, read. lookahead );
   break;
case 16:
   reduction_16( parsestack, cont, bottom, parsestack. end( ) - 5, parsestack. end( ) - 5, parsestack. end( ) - 4, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 17:
   reduction_17( parsestack, parsestack. end( ) - 3, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 18:
   reduction_18( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 19:
   reduction_19( parsestack, cont, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 20:
   reduction_20( parsestack, cont, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 21:
   reduction_21( parsestack, cont, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 22:
   reduction_22( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 23:
   reduction_23( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 24:
   reduction_24( parsestack, parsestack. end( ) - 4, parsestack. end( ) - 4, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 25:
   reduction_25( parsestack, parsestack. end( ) - 4, parsestack. end( ) - 4, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 26:
   reduction_26( parsestack, parsestack. end( ) - 2, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 27:
   reduction_27( parsestack, cont, parsestack. end( ) - 5, parsestack. end( ) - 5, parsestack. end( ) - 4, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 28:
   reduction_28( parsestack, cont, parsestack. end( ) - 5, parsestack. end( ) - 5, parsestack. end( ) - 4, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 29:
   reduction_29( parsestack, parsestack. end( ) - 2, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 30:
   reduction_30( parsestack, parsestack. end( ) - 2, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 31:
   reduction_31( parsestack, parsestack. end( ) - 2, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 32:
   reduction_32( parsestack, cont, parsestack. end( ) - 5, parsestack. end( ) - 5, parsestack. end( ) - 4, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 33:
   reduction_33( parsestack, cont, pr, parsestack. end( ) - 10, parsestack. end( ) - 10, parsestack. end( ) - 9, parsestack. end( ) - 8, parsestack. end( ) - 7, parsestack. end( ) - 6, parsestack. end( ) - 5, parsestack. end( ) - 4, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 34:
   reduction_34( parsestack, cont, parsestack. end( ) - 5, parsestack. end( ) - 5, parsestack. end( ) - 4, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 35:
   reduction_35( parsestack, parsestack. end( ) - 3, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 36:
   reduction_36( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 37:
   reduction_37( parsestack, parsestack. end( ) - 0 );
   break;
case 38:
   reduction_38( parsestack, cont, parsestack. end( ) - 2, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 39:
   reduction_39( parsestack, cont, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 40:
   reduction_40( parsestack, cont, parsestack. end( ) - 3, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 41:
   reduction_41( parsestack, cont, parsestack. end( ) - 3, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 42:
   reduction_42( parsestack, parsestack. end( ) - 4, parsestack. end( ) - 4, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 43:
   reduction_43( parsestack, parsestack. end( ) - 6, parsestack. end( ) - 6, parsestack. end( ) - 5, parsestack. end( ) - 4, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 44:
   reduction_44( parsestack, parsestack. end( ) - 3, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 45:
   reduction_45( parsestack, cont, parsestack. end( ) - 7, parsestack. end( ) - 7, parsestack. end( ) - 6, parsestack. end( ) - 5, parsestack. end( ) - 4, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 46:
   reduction_46( parsestack, cont, parsestack. end( ) - 7, parsestack. end( ) - 7, parsestack. end( ) - 6, parsestack. end( ) - 5, parsestack. end( ) - 4, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 47:
   reduction_47( parsestack, cont, parsestack. end( ) - 5, parsestack. end( ) - 5, parsestack. end( ) - 4, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 48:
   reduction_48( parsestack, cont, parsestack. end( ) - 5, parsestack. end( ) - 5, parsestack. end( ) - 4, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 49:
   reduction_49( parsestack, parsestack. end( ) - 2, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 50:
   reduction_50( parsestack, parsestack. end( ) - 0 );
   break;
case 51:
   reduction_51( parsestack, parsestack. end( ) - 3, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 52:
   reduction_52( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 53:
   reduction_53( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 54:
   reduction_54( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 55:
   reduction_55( parsestack, parsestack. end( ) - 3, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 56:
   reduction_56( parsestack, parsestack. end( ) - 3, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 57:
   reduction_57( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 58:
   reduction_58( parsestack, parsestack. end( ) - 3, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 59:
   reduction_59( parsestack, parsestack. end( ) - 3, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 60:
   reduction_60( parsestack, parsestack. end( ) - 3, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 61:
   reduction_61( parsestack, parsestack. end( ) - 3, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 62:
   reduction_62( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 63:
   reduction_63( parsestack, parsestack. end( ) - 3, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1, read. lookahead );
   break;
case 64:
   reduction_64( parsestack, parsestack. end( ) - 3, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1, read. lookahead );
   break;
case 65:
   reduction_65( parsestack, parsestack. end( ) - 3, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1, read. lookahead );
   break;
case 66:
   reduction_66( parsestack, parsestack. end( ) - 3, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1, read. lookahead );
   break;
case 67:
   reduction_67( parsestack, parsestack. end( ) - 2, parsestack. end( ) - 2, parsestack. end( ) - 1, read. lookahead );
   break;
case 68:
   reduction_68( parsestack, parsestack. end( ) - 2, parsestack. end( ) - 2, parsestack. end( ) - 1, read. lookahead );
   break;
case 69:
   reduction_69( parsestack, parsestack. end( ) - 2, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 70:
   reduction_70( parsestack, parsestack. end( ) - 3, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 71:
   reduction_71( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 72:
   reduction_72( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 73:
   reduction_73( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 74:
   reduction_74( parsestack, parsestack. end( ) - 3, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 75:
   reduction_75( parsestack, parsestack. end( ) - 4, parsestack. end( ) - 4, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 76:
   reduction_76( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 77:
   reduction_77( parsestack, parsestack. end( ) - 3, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 78:
   reduction_78( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 79:
   reduction_79( parsestack, parsestack. end( ) - 4, parsestack. end( ) - 4, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 80:
   reduction_80( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;
case 81:
   reduction_81( parsestack, parsestack. end( ) - 3, parsestack. end( ) - 3, parsestack. end( ) - 2, parsestack. end( ) - 1 );
   break;
case 82:
   reduction_82( parsestack, parsestack. end( ) - 1, parsestack. end( ) - 1 );
   break;

            default:
	       std::cout << "unknown rule!\n";
	       exit(0); 
            }

#ifdef MAPH_DEBUG
            std::cout << "reduced rule " << rule << "\n";
#endif

            ASSERT( parsestack. size( )); 

            ASSERT( states. size( ) >= parsestack. size( ));

            while( states. size( ) > parsestack. size( ))
               states. pop_back( );

            // We now need to shift the lhs of the rule.
            // We do not like to copy tokens, because their attributes
            // can be big without borders. Copying can be avoided 
            // using list specific operations. 

            std::list< token > :: iterator p = parsestack. end( ) - 1;
            read. lookahead. splice( read. lookahead. begin( ), 
                                     parsestack, p );
               // Now the back of the parsestack is in front of lookahead.
               // It is possible that lookahead has a length of two now.

            actions = decideaction( states. back( ), read ); 

            // The action list should consist of a single push:

            ASSERT( actions. size( ) == 1 && actions. front( ) > 0 );

#ifdef MAPH_DEBUG
            std::cout << "goto " << actions. front( ) - 10000 << "\n"; 
#endif
            // We do not carry out the goto. 

            ++ errorcount;
         }
         catch( refused ref )
         {
#ifdef MAPH_DEBUG
            std::cout << "rule " << rule << " refused\n";
#endif
            actions. pop_front( );
               // But we are not sad about the refusal. We simply try the
               // next. 
         }
      }   
 
      if( actions. size( ) == 1 && actions. front( ) > 0 ) 
      {
         ASSERT( read. lookahead. size( ) == 1 || 
                 read. lookahead. size( ) == 2 );
         actions. front( ) -= 10000;
#ifdef MAPH_DEBUG
         std::cout << "shifting " << read. lookahead. front( ) << "\n"; 
#endif
 
         if( errorcount > 0 ) 
	    -- errorcount; 

         parsestack. splice( parsestack. end( ), 
                             read. lookahead, read. lookahead. begin( ));
            // This puts the symbol on the parsestack without moving it. 

         states. push_back( actions. front( ));

      }
      else
      {
         // If there is something left in actions, it is an error.

         ASSERT( actions. size( ) == 1 && actions. front( ) == 0 );
         ASSERT( read. lookahead. size( ));

#ifdef MAPH_DEBUG
        std::cout << "error!\n"; 
#endif

         // It is the responsability of the reader to process the error:

         read. syntaxerror( );
 
         // Recovery will be the level at which we can recover.
         // As long as we did not recover, it will be -1.
 
         int recovery = -1; 
         unsigned int ignoredtokens = 0;

         while( recovery < 0 && ! isstartlookahead( entry, read ) && 
                ignoredtokens < recoverlength )
         {
            // Our approach is simple and inefficient, we look for
            // states that can push a recovery symbol, and after that
            // would be able to push the current lookahead symbol.

            std::list< unsigned int > :: const_iterator p = states. begin( );

            for( unsigned int k = 0; k < states. size( ); ++ k )
            {
               read. lookahead. push_front( token::token( tkn__recover ));
               actions = decideaction( *p, read );
               read. lookahead. pop_front( );

               if( actions. size( ) == 1 && actions. front( ) > 0 )
               {
                  // Recover transition is possible. 

                  unsigned int trans = actions. front( ) - 10000; 
                  actions = decideaction( trans, read );
               
                  if( actions. size( ) == 1 && actions. front( ) > 0 )
                     recovery = k;
                        // We remember that recovery was possible.
                        // If more than recovery is possible, we will
                        // remember the highest in recovery. 
               }
            
               ++ p;
            }
       
            if( recovery < 0 )
            {
               read. lookahead. clear( );
               ++ ignoredtokens;
               read. scan( );
               ASSERT( read. lookahead. size( )); 
            }
         }

#ifdef MAPH_DEBUG 
         std::cout << "recovery = " << recovery << "\n";
         if( read. lookahead. size( ))
         {
            std::cout << "lookahead = ";
            std::cout << read. lookahead. front( ) << "\n";
         }
#endif

         if( ignoredtokens >= recoverlength ) 
         {
            // That was it. We lost.

            read. lookahead. clear( );
            read. lookahead. push_front( tkn__recover );
            return;
         }

         if( isstartlookahead( entry, read ))
         {
            // We reached a lookahead symbol of the grammar. 
            // We admit our defeat. 

            return;
         } 

         while( states. size( ) > recovery + 1 )
         {
            states. pop_back( );
            parsestack. pop_back( ); 
         }

         read. lookahead. push_front( token::token( tkn__recover ));
         actions = decideaction( states. back( ), read );
         read. lookahead. pop_front( );

         ASSERT( actions. size( ) == 1 && actions. front( ) > 0 );
         actions. front( ) -= 10000;
       
         states. push_back( actions. front( ));
         parsestack. push_back( token::token( tkn__recover ));

         actions = decideaction( states. back( ), read );
     
         ASSERT( actions. size( ) == 1 && actions. front( ) > 0 );
         actions. front( ) -= 10000;

#ifdef MAPH_DEBUG
         std::cout << "recovering into state " << actions. front( );
         std::cout << " using token " << read. lookahead. front( ) << "\n";
#endif

         states. push_back( actions. front( ));
         parsestack. splice( parsestack. end( ),
                             read. lookahead, read. lookahead. begin( ));

         errorcount = 3;
      }
   }
}


